﻿Imports System.Runtime.InteropServices
Imports System.IO
Imports mshtml

Public Class Form1
   Dim SB As New System.Text.StringBuilder()
   Private Delegate Sub УказательНаМетод_Navigate(ByVal Browser As WebBrowser, ByVal UrlString As String)

   Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
      WebBrowser1.Dispose() : WebBrowser2.Dispose() : WebBrowser3.Dispose()
   End Sub

   Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      AddHandler WebBrowser1.DocumentCompleted, AddressOf DocumentCompleted
      AddHandler WebBrowser2.DocumentCompleted, AddressOf DocumentCompleted
      AddHandler WebBrowser3.DocumentCompleted, AddressOf DocumentCompleted
   End Sub

   Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
      Dim NavigateProc As New УказательНаМетод_Navigate(AddressOf Navigate)

      WebBrowser1.BeginInvoke(NavigateProc, WebBrowser1, "http://www.techdays.ru/Registration.aspx")
      WebBrowser2.BeginInvoke(NavigateProc, WebBrowser2, "http://yandex.ru")
      WebBrowser3.BeginInvoke(NavigateProc, WebBrowser3, "http://www.mail.ru")
   End Sub

   Private Sub Navigate(ByVal Browser As WebBrowser, ByVal UrlString As String)
      Browser.Navigate(UrlString)
   End Sub

   Private Sub DocumentCompleted(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs)
      Dim browser As WebBrowser = DirectCast(sender, WebBrowser)
      Dim path As String = "c:\temp\savedImages\" & browser.Document.Url.Host & "\"
      If Not Directory.Exists(path) Then Directory.CreateDirectory(path)
      SaveImage(browser.Document.Images, path)
   End Sub


   Sub SaveImage(ByVal images As System.Windows.Forms.HtmlElementCollection, ByVal ImagePath As String)
      Dim i, width, height As Integer
      Dim FullPath As String
      Dim img As Image
      Dim Img1 As mshtml.IHTMLElement


      For Each oneImage As HtmlElement In images
         i += 1
         Img1 = oneImage.DomElement
         Dim rendElem As ScreenGrab.IHTMLElementRender = TryCast(Img1, ScreenGrab.IHTMLElementRender)
         Dim hdcDestination As IntPtr

         width = Img1.clientWidth
         height = Img1.clientHeight
         If width = 0 Or height = 0 Then Continue For
         img = New Bitmap(width, height)

         Using Gr As Graphics = Graphics.FromImage(img)
            hdcDestination = Gr.GetHdc()
            rendElem.DrawToDC(hdcDestination)
            Gr.ReleaseHdc(hdcDestination)
            FullPath = Path.Combine(ImagePath, "Image" & i & ".png")
            img.Save(FullPath, System.Drawing.Imaging.ImageFormat.Emf)
         End Using
         img.Dispose()
      Next
   End Sub
End Class


Namespace ScreenGrab
   <Guid("3050f669-98b5-11cf-bb82-00aa00bdce0b"), InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown), ComVisible(True), ComImport()> _
   Interface IHTMLElementRender
      Sub DrawToDC(<[In]()> ByVal hDC As IntPtr)
      Sub SetDocumentPrinter(<[In](), MarshalAs(UnmanagedType.BStr)> ByVal bstrPrinterName As String, <[In]()> ByVal hDC As IntPtr)
   End Interface
End Namespace


